!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine difcof
     &(lmhk,gm,gh,el,q2,z,akm,akh)
!     ******************************************************************
!     *                                                                *
!     *               level 2.5 diffusion coefficients                 *
!     *             Janjic, 2001, NCEP Office Note #436.               *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      include "parmeta"
!-----------------------------------------------------------------------
      parameter
     &(lp1=lm+1,lm1=lm-1)
!-----------------------------------------------------------------------
      parameter
!-----------------------------------------------------------------------
     &(g=9.806,beta=1./273.,btg=beta*g
     &,prt=1.0,gam1=0.2222222222222222222
     &,a1=0.659888514560862645,a2=0.6574209922667784586
     &,b1=11.87799326209552761,b2=7.226971804046074028
     &,c1=0.000830955950095854396)
!-----------------------------------------------------------------------
cun     &(g=9.8,beta=1./273.,btg=beta*g
cun     &,prt=1.0,gam1=0.2222222222222222222
cun     &,a1=0.3310949523016403346,a2=0.8273378704055731278
cun     &,b1=5.959709141429526024,b2=3.626088092074591135
cun     &,c1=-0.3330651924968952113)
!-----------------------------------------------------------------------
cmy     &(g=9.8,beta=1./273.,btg=beta*g
cmy     &,prt=0.8,gam1=0.2222222222222222222
cmy     &,a1=0.9222222350809054114,a2=0.7350190142719400952
cmy     &,b1=16.60000023145629741,b2=10.10000014082581951
cmy     &,c1=0.0805318118080613468)
!-----------------------------------------------------------------------
      parameter
!--------------coefficients for the sm and sh determinants--------------
     &(bsmh=-3.*a1*a2*(3.*a2+3.*b2*c1+12.*a1*c1-b2)*btg
     &,cesm=    a1*(1.-3.*c1)
c
     &,bshm=18.*a1*a1*a2*c1
     &,bshh= 9.*a1*a2*a2*btg
     &,cesh=    a2
!--------------coefficients of the terms in the denominator-------------
     &,adnm=18.*a1*a1*a2*(b2-3.*a2)*btg
     &,adnh= 9.*a1*a2*a2*(12.*a1+3.*b2)*btg*btg
     &,bdnm= 6.*a1*a1
     &,bdnh= 3.*a2*(7.*a1+b2)*btg)
!-----------------------------------------------------------------------
      dimension
     & q2    (lm)
      dimension
     & gm    (lm1),gh    (lm1),el    (lm1)
     &,akm   (lm1),akh   (lm1)
     &,z     (lp1)
!***********************************************************************
      lmhm=lmhk-1
      lmhp=lmhk+1
          do l=1,lmhm
      ell=el(l)
!-----------------------------------------------------------------------
      eloq2=ell*ell/q2(l)
      eloq4=eloq2*eloq2
!-----------------------------------------------------------------------
      gml=gm(l)
      ghl=gh(l)
!--------------coefficients of the terms in the denominator-------------
      aden=(adnm*gml+adnh*ghl)*ghl
      bden= bdnm*gml+bdnh*ghl
      cden= 1.
!--------------coefficients for the sm determinant----------------------
      besm=bsmh*ghl
!--------------coefficients for the sh determinant----------------------
      besh=bshm*gml+bshh*ghl
!--------------1./denominator-------------------------------------------
      rden=1./(aden*eloq4+bden*eloq2+cden)
!--------------sm and sh------------------------------------------------
      esm=(besm*eloq2+cesm)*rden
      esh=(besh*eloq2+cesh)*rden
!--------------diffusion coefficients-----------------------------------
      rdz=2./(z(l)-z(l+2))
      q1l=sqrt(q2(l))
      elqdz=ell*q1l*rdz
      akm(l)=elqdz*esm ! normal residual diff. coff.
      akh(l)=elqdz*esh ! normal residual diff. coff.
!zj      akm(l)=max(elqdz*esm,0.5*rdz) ! enhanced residual diff. coff.
!zj      akh(l)=max(elqdz*esh,0.5*rdz) ! enhanced residual diff. coff.
!-----------------------------------------------------------------------
          enddo
!-----------------------------------------------------------------------
                             return
                             end
