C&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
                             SUBROUTINE HADZ 
C     ******************************************************************
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .     
C SUBPROGRAM:    HADZ        HORIZONTAL ADVECTION OF HEIGHT
C   PRGRMMR: JANJIC          ORG: W/NMC2     DATE: 96-05-??       
C     
C ABSTRACT:
C     HADZ CALCULATES DIAGNOSTICALLY THE CONTRIBUTION OF
C     THE HORIZONTAL ADVECTION OF HEIGHT
C     
C PROGRAM HISTORY LOG:
C   96-05-??  JANJIC     - ORIGINATOR
C   00-01-04  BLACK      - DISTRIBUTED MEMORY AND THREADS
C
C USAGE: CALL HADZ FROM MAIN PROGRAM
C   INPUT ARGUMENT LIST:
C       NONE
C
C   OUTPUT ARGUMENT LIST:
C     NONE
C
C   OUTPUT FILES:
C     NONE
C
C   SUBPROGRAMS CALLED:
C
C     UNIQUE: NONE
C
C     LIBRARY: NONE
C
C   COMMON BLOCKS: CTLBLK
C                  LOOPS
C                  MASKS
C                  DYNAM
C                  VRBLS
C                  CONTIN
C                  NHYDRO
C                  INDX
C ATTRIBUTES:
C   LANGUAGE: FORTRAN 90
C   MACHINE : IBM SP
C$$$
C***********************************************************************
C-----------------------------------------------------------------------
      INCLUDE "parmeta"
      INCLUDE "mpp.h"
C-----------------------------------------------------------------------
                             P A R A M E T E R
     &(JAM=6+2*(JM-10)
     &,IMJM=IM*JM-JM/2,LM1=LM-1,LP1=LM+1)
                             P A R A M E T E R
     &(G=9.806,NTSHY=2)
C-----------------------------------------------------------------------
                             L O G I C A L
     & RUN,FIRST,RESTRT,SIGMA
C----------------------------------------------------------------------
      INCLUDE "CTLBLK.comm"
C-----------------------------------------------------------------------
      INCLUDE "LOOPS.comm"
C-----------------------------------------------------------------------
      INCLUDE "MASKS.comm"
C-----------------------------------------------------------------------
      INCLUDE "DYNAM.comm"
C-----------------------------------------------------------------------
      INCLUDE "VRBLS.comm"
c-----------------------------------------------------------------------
      include "CONTIN.comm"
C-----------------------------------------------------------------------
      INCLUDE "NHYDRO.comm"
C-----------------------------------------------------------------------
      INCLUDE "INDX.comm"
C-----------------------------------------------------------------------
                             R E A L
     & HBMS  (IDIM1:IDIM2,JDIM1:JDIM2),DPDE  (IDIM1:IDIM2,JDIM1:JDIM2)
     &,UNED  (IDIM1:IDIM2,JDIM1:JDIM2),USED  (IDIM1:IDIM2,JDIM1:JDIM2)
     &,ZEW   (IDIM1:IDIM2,JDIM1:JDIM2),ZNS   (IDIM1:IDIM2,JDIM1:JDIM2)
     &,ZNE   (IDIM1:IDIM2,JDIM1:JDIM2),ZSE   (IDIM1:IDIM2,JDIM1:JDIM2)
C-----------------------------------------------------------------------
C
      IF(NTSD.LE.NTSHY.OR.HYDRO)THEN
!$omp parallel do
        DO L=1,LM
          DO J=MYJS,MYJE
          DO I=MYIS,MYIE
            W(I,J,L)=0.
          ENDDO
          ENDDO
        ENDDO
C***
        RETURN
C***
      ENDIF
C***********************************************************************
C-----------------------------------------------------------------------
!      call zero3(few)
!      call zero3(fns)
!      call zero3(fse)
!      call zero3(fne)
!$omp parallel do 
!$omp& private (dpde,ihh,ihl,ivh,ivl,ix,jx,udy,uned,used,
!$omp&          vdx,zew,zne,zns,zse)
      DO 200 L=1,LM
C-----------------------------------------------------------------------
      DO J=MYJS_P3,MYJE_P3
      DO I=MYIS_P3,MYIE_P3
        dpde(i,j)=deta1(l)*pdtop+deta2(l)*pdsl(i,j)
      ENDDO
      ENDDO
C--------------MASS FLUXES AND MASS POINTS ADVECTION COMPONENTS---------
              do j=myjs1_p3,myje1_p3
          do i=myis_p3,myie_p3
      udy=u(i,j,l)*dy
      vdx=v(i,j,l)*dx(i,j)
!
      fewp=udy*(dpde(i+ivw(j),j  )+dpde(i+ive(j),j  ))
      fnsp=vdx*(dpde(i       ,j-1)+dpde(i       ,j+1))
!
      few(i,j,l)=fewp
      fns(i,j,l)=fnsp
!
      zew(i,j)=fewp
     2        *(z   (i+ive(j),j  ,l)-z   (i+ivw(j),j  ,l))
      zns(i,j)=fnsp
     2        *(z   (i       ,j+1,l)-z   (i       ,j-1,l))
!
      uned(i,j)=udy+vdx
      used(i,j)=udy-vdx
          enddo
              enddo
!--------------DIAGONAL FLUXES AND DIAGONALLY AVERAGED WIND-------------
              do j=myjs1_p2,myje2_p2
          do i=myis_p2,myie1_p2
      fnep=(uned(i+ihe(j),j)+uned(i       ,j+1))
     1    *(dpde(i       ,j)+dpde(i+ihe(j),j+1))
      fne(i,j,l)=fnep
      zne(i,j)=fnep
     2        *(z   (i+ihe(j),j+1,l)-z  (i,j,l))
          enddo
              enddo
!
              do j=myjs2_p2,myje1_p2
          do i=myis_p2,myie1_p2
      fsep=(used(i+ihe(j),j)+used(i       ,j-1))
     1    *(dpde(i       ,j)+dpde(i+ihe(j),j-1))
      fse(i,j,l)=fsep
      zse(i,j)=fsep
     2        *(z   (i+ihe(j),j-1,l)-z  (i,j,l))
          enddo
              enddo
!--------------ADVECTION OF Z-------------------------------------------
              do j=myjs2_p1,myje2_p1
          do i=myis1_p1,myie1_p1
      w(i,j,l)=
     1        -(zew(i+ihw(j),j  )+zew(i+ihe(j),j  )
     1         +zns(i       ,j-1)+zns(i       ,j+1)
     2         +zne(i+ihw(j),j-1)+zne(i       ,j  )
     2         +zse(i       ,j  )+zse(i+ihw(j),j+1))
     3         *fad(i,j)*htm(i,j,l)*hbm2(i,j)/(dpde(i,j)*dt)
     4        +w(i,j,l)
          enddo
              enddo
C-----------------------------------------------------------------------
  200 CONTINUE
C-----------------------------------------------------------------------
C***********************************************************************
c      NSMUD=7
c      DO J=MYJS,MYJE
c      DO I=MYIS,MYIE
c        HBMS(I,J)=HBM2(I,J)
c      ENDDO
c      ENDDO
cC
cC    JHL MUST BE ODD!!!
c      JHL=9
c      JHH=JM-JHL+1
cC
c      DO 225 J=JHL,JHH
c      IF(J.GE.MY_JS_GLB.AND.J.LE.MY_JE_GLB)THEN
c        JX=J-MY_JS_GLB+1
c        IHL=JHL/2+1
c        IHH=IM-IHL+MOD(J,2)
c        DO I=IHL,IHH
c        IF(I.GE.MY_IS_GLB.AND.I.LE.MY_IE_GLB)THEN
c          IX=I-MY_IS_GLB+1
c          HBMS(IX,JX)=0.
c        ENDDO
c      ENDIF
c  225 CONTINUE
cC-----------------------------------------------------------------------
c!#omp paralle do private (ihh,ihl,ix,jx,zne,zse)
c      DO 300 L=1,LM
cC-----------------------------------------------------------------------
c      DO KS=1,NSMUD
cC
c        DO J=MYJS,MYJE1
c        DO I=MYIS,MYIE1
c          ZNE(I,J)=(W(I+IHE(J),J+1,L)-W(I,J,L))
c     &             *HTM(I,J,L)*HTM(I+IHE(J),J+1,L)
c        ENDDO
c        ENDDO
cC
c        DO J=MYJS1,MYJE
c        DO I=MYIS,MYIE1
c          ZSE(I,J)=(W(I+IHE(J),J-1,L)-W(I,J,L))
c     &             *HTM(I+IHE(J),J-1,L)*HTM(I,J,L)
c        ENDDO
c        ENDDO
cC
c        DO 250 J=3,JM-2
c        IF(J.GE.MY_JS_GLB.AND.J.LE.MY_JE_GLB)THEN
c          JX=J-MY_JS_GLB+1
c          IHL=2
c          IHH=IM-2+MOD(J,2)
cC
c          DO 245 I=2,IM-2
c          IF(I.GE.MY_IS_GLB.AND.I.LE.MY_IE_GLB)THEN
c            IX=I-MY_IS_GLB+1
c            W(IX,JX,L)=(ZNE(IX,JX)-ZNE(IX+IHW(JX),JX-1)
c     &           +ZSE(IX,JX)-ZSE(IX+IHW(JX),JX+1))
c     &          *HBMS(IX,JX)*0.125+W(IX,JX,L)
c          ENDIF
c  245     CONTINUE
c        ENDIF
c  250   CONTINUE
c      ENDDO
cC----------------------------------------------------------------------
c  300 CONTINUE
cC----------------------------------------------------------------------
      RETURN
      END
