!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine prodq2
     &(lmhk,dtq2,ustar,gm,gh,el,q2)
!     ******************************************************************
!     *                                                                *
!     *             level 2.5 q2 production/dissipation                *
!     *             Janjic, 2001, NCEP Office Note #436.               *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      include "parmeta"
!-----------------------------------------------------------------------
      parameter
     &(lm1=lm-1)
!-----------------------------------------------------------------------
      parameter
     &(epsq2=0.20,epsl=0.32,epstrb=1.e-24,eps1=1.e-12,eps2=0.)
!-----------------------------------------------------------------------
      parameter
!-----------------------------------------------------------------------
     &(g=9.806,beta=1./273.,btg=beta*g
     &,prt=1.0,gam1=0.2222222222222222222
     &,a1=0.659888514560862645,a2=0.6574209922667784586
     &,b1=11.87799326209552761,b2=7.226971804046074028
     &,c1=0.000830955950095854396)
!-----------------------------------------------------------------------
cun     &(g=9.8,beta=1./273.,btg=beta*g
cun     &,prt=1.0,gam1=0.2222222222222222222
cun     &,a1=0.3310949523016403346,a2=0.8273378704055731278
cun     &,b1=5.959709141429526024,b2=3.626088092074591135
cun     &,c1=-0.3330651924968952113)
!-----------------------------------------------------------------------
cmy     &(g=9.8,beta=1./273.,btg=beta*g
cmy     &,prt=0.8,gam1=0.2222222222222222222
cmy     &,a1=0.9222222350809054114,a2=0.7350190142719400952
cmy     &,b1=16.60000023145629741,b2=10.10000014082581951
cmy     &,c1=0.0805318118080613468)
!-----------------------------------------------------------------------
      parameter
     &(rb1=1./b1
!--------------coefficients of the terms in the numerator---------------
     &,anmm=-3.*a1*a2*(3.*a2+3.*b2*c1+18.*a1*c1-b2)*btg
     &,anmh=-9.*a1*a2*a2*btg*btg
     &,bnmm=    a1*(1.-3.*c1)
     &,bnmh=   -a2*btg
!--------------coefficients of the terms in the denominator-------------
     &,adnm=18.*a1*a1*a2*(b2-3.*a2)*btg
     &,adnh= 9.*a1*a2*a2*(12.*a1+3.*b2)*btg*btg
     &,bdnm= 6.*a1*a1
     &,bdnh= 3.*a2*(7.*a1+b2)*btg
!--------------coefficients of the equilibrium equation-----------------
     &,aeqm= 3.*a1*a2*b1*(3.*a2+3.*b2*c1+18.*a1*c1-b2)*btg
     &     +18.*a1*a1*a2*(b2-3.*a2)*btg
     &,aeqh= 9.*a1*a2*a2*b1*btg*btg+9.*a1*a2*a2*(12.*a1+3.*b2)*btg*btg
     &,beqm=-a1*b1*(1.-3.*c1)+6.*a1*a1
     &,beqh= a2*b1*btg+3.*a2*(7.*a1+b2)*btg
!--------------forbidden turbulence area--------------------------------
     &,requ=-aeqh/aeqm,epsgh=1.e-9)
!-----------------------------------------------------------------------
      dimension
     & q2    (lm)
      dimension
     & gm    (lm1),gh    (lm1),el    (lm1)
!***********************************************************************
      lmhm=lmhk-1
!
          do l=1,lmhm
      gml=gm(l)
      ghl=gh(l)
!--------------coefficients of the equilibrium equation-----------------
      aequ=(aeqm*gml+aeqh*ghl)*ghl
      bequ= beqm*gml+beqh*ghl
!--------------equilibrium solution for l/q-----------------------------
      eqol2=-0.5*bequ+sqrt(bequ*bequ*0.25-aequ)
!--------------is there production/dissipation ?------------------------
          if((gml+ghl*ghl.le.epstrb           )
     &   .or.(ghl.ge.epsgh.and.gml/ghl.le.requ)
     &   .or.(eqol2.le.eps2)                  )    then
!--------------no turbulence--------------------------------------------
      q2(l)=epsq2
      el(l)=epsl
!--------------end of the no turbulence branch--------------------------
          else
!--------------coefficients of the terms in the numerator---------------
      anum=(anmm*gml+anmh*ghl)*ghl
      bnum= bnmm*gml+bnmh*ghl
!--------------coefficients of the terms in the denominator-------------
      aden=(adnm*gml+adnh*ghl)*ghl
      bden= bdnm*gml+bdnh*ghl
      cden= 1.
!--------------coefficients of the numerator of the linearized eq.------
      arhs=-(anum*bden-bnum*aden)*2.
      brhs=- anum*4.
      crhs=- bnum*2.
!--------------initial value of l/q-------------------------------------
      dloq1=el(l)/sqrt(q2(l))
!--------------first iteration for l/q, rhs=0---------------------------
      eloq21=1./eqol2
      eloq11=sqrt(eloq21)
      eloq31=eloq21*eloq11
      eloq41=eloq21*eloq21
      eloq51=eloq21*eloq31
!--------------1./denominator-------------------------------------------
      rden1=1./(aden*eloq41+bden*eloq21+cden)
!--------------d(rhs)/d(l/q)--------------------------------------------
      rhsp1= (arhs*eloq51+brhs*eloq31+crhs*eloq11)*rden1*rden1
!--------------first-guess solution-------------------------------------
      eloq12=eloq11+(dloq1-eloq11)*exp(rhsp1*dtq2)
!-----------------------------------------------------------------------
      eloq12=max(eloq12,eps1)
!--------------second iteration for l/q---------------------------------
      eloq22=eloq12*eloq12
      eloq32=eloq22*eloq12
      eloq42=eloq22*eloq22
      eloq52=eloq22*eloq32
!--------------1./denominator-------------------------------------------
      rden2=1./(aden*eloq42+bden*eloq22+cden)
!-----------------------------------------------------------------------
      rhs2 =-(anum*eloq42+bnum*eloq22)*rden2+rb1
      rhsp2= (arhs*eloq52+brhs*eloq32+crhs*eloq12)*rden2*rden2
      rhst2=rhs2/rhsp2
!--------------corrected solution---------------------------------------
      eloq13=eloq12-rhst2+(rhst2+dloq1-eloq12)*exp(rhsp2*dtq2)
!-----------------------------------------------------------------------
      eloq13=max(eloq13,eps1)
!--------------two iterations is enough in most cases ...---------------
      eloqn=eloq13
!-----------------------------------------------------------------------
      if(eloqn.gt.eps1)then
        q2(l)=el(l)*el(l)/(eloqn*eloqn)
        q2(l)=max(q2(l),epsq2)
      else
        q2(l)=epsq2
      endif
!--------------end of turbulent branch----------------------------------
          endif
!--------------end of production/dissipation loop-----------------------
          enddo
!--------------lower boundary condition for q2--------------------------
      q2(lmhk)=max(b1**(2./3.)*ustar*ustar,epsq2)
!-----------------------------------------------------------------------
                             return
                             end
