!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine sfcdif
     &(sm,ths,qs,uz0,vz0,tz0,thz0,qz0
     &,ustar,wstar,z0,akms,akhs,hpbl,ct
     &,u10,v10,th02,th10,q02,q10
     &,ulm,vlm,tlm,thlm,thvlm,qlm,clm,zsl)
!     ******************************************************************
!     *                                                                *
!     *                        surface layer                           *
!     *               responsible person: z.janjic                     *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      parameter
     &(elivw=2.72e6,elocp=elivw/1004.6)
      parameter
     &(wwst=1.2,wwst2=wwst*wwst,g=9.806,ustfc=0.018/g
     &,vkrm=0.40,ric=0.505,excml=0.001,excms=0.001
     &,itrmx=05
!-----------------------------------------------------------------------
     &,epsu2=1.e-4,epsust=0.07
!-----------------------------------------------------------------------
     &,small=0.35, glkbs=30.0,glkbr=10.0,grrs=glkbr/glkbs
     &,cziv=small*glkbs
     &,visc=1.5e-5, tvisc=2.1e-5, qvisc=2.1e-5
     &,rvisc=1./visc,rtvisc=1./tvisc,rqvisc=1./qvisc
     &,sqpr=0.84,sqsc=0.84,zqrzt=sqsc/sqpr
     &,ustr=0.225,ustc=0.7
     &,fzu1=cziv*visc,fzt1=rvisc *tvisc*sqpr,   fzq1=rtvisc*qvisc*zqrzt
     &,               fzt2=cziv*grrs*tvisc*sqpr,fzq2=rtvisc*qvisc*zqrzt
!-----------------------------------------------------------------------
     &,ztfc=1.0
     &,czil=0.2,sqvisc=258.2,zilfc=-czil*vkrm*sqvisc,epszt=0.00001)
!-----------------------------------------------------------------------
      include "psi.comm"
!***********************************************************************
      rdz=1./zsl
      cxchl=excml*rdz
      cxchs=excms*rdz
!
      btg=g/thlm
      elfc=vkrm*btg
!
          if(hpbl.gt.1000.) then
      btgh=btg*hpbl
          else
      btgh=btg*1000.
          endif
!-----------------------------------------------------------------------
                      if(sm.gt.0.) then  !  sea points
!-----------------------------------------------------------------------
          do itr=1,itrmx
!-----------------------------------------------------------------------
      z0=max(ustfc*ustar*ustar,1.59e-5)
!--------------viscous sublayer, janjic mwr 1994------------------------
              if(ustar.lt.ustc)then
          if(ustar.lt.ustr)then
      zu=fzu1*sqrt(sqrt(z0*ustar*rvisc))/ustar
      wght=akms*zu*rvisc
      rwgh=wght/(wght+1.)
      uz0=(ulm*rwgh+uz0)*0.5
      vz0=(vlm*rwgh+vz0)*0.5
!
      zt=fzt1*zu
      wght=akhs*zt*rtvisc
      thz0=((wght*thlm+ths)/(wght+1.)+thz0)*0.5
!
      zq=fzq1*zt
      wght=akhs*zq*rqvisc
      qz0=((wght*qlm+qs)/(wght+1.)+qz0)*0.5
          endif
          if(ustar.ge.ustr.and.ustar.lt.ustc)then
      zu=z0
      uz0=0.
      vz0=0.
!
      zt=fzt2*sqrt(sqrt(z0*ustar*rvisc))/ustar
      wght=akhs*zt*rtvisc
      thz0=((wght*thlm+ths)/(wght+1.)+thz0)*0.5
!
      zq=fzq2*zt
      wght=akhs*zq*rqvisc
      qz0=((wght*qlm+qs)/(wght+1.)+qz0)*0.5
          endif
!-----------------------------------------------------------------------
              else
!-----------------------------------------------------------------------
          zu=z0
          uz0=0.
          vz0=0.
!
          zt=z0
          thz0=ths
!
          zq=z0
          qz0=qs
!-----------------------------------------------------------------------
              endif
!-----------------------------------------------------------------------
      tem=(tlm+tz0)*0.5
      thm=(thvlm+thz0)*0.5
!
      a=thm*0.608
      b=(elocp/tem-1.608)*thm
!
      dthv=((thvlm-thz0)*((qlm+qz0)*(0.5*0.608)+1.)
     &     +(qlm-qz0)*a
     &     +clm*b)
!
      du2=max((ulm-uz0)**2+(vlm-vz0)**2,epsu2)
      rib=btg*dthv*zsl/du2
!-----------------------------------------------------------------------
!          if(rib.ge.ric)then
!-----------------------------------------------------------------------
!      akms=max( visc*rdz,cxchs)
!      akhs=max(tvisc*rdz,cxchs)
!-----------------------------------------------------------------------
!          else  !  turbulent branch
!-----------------------------------------------------------------------
      zslu=zsl+zu
      zslt=zsl+zt
!
      rzsu=zslu/zu
      rzst=zslt/zt
!
      rlogu=log(rzsu)
      rlogt=log(rzst)
!--------------1./monin-obukhov length----------------------------------
      rlmo=elfc*akhs*dthv/ustar**3
!
      zetalu=zslu*rlmo
      zetalt=zslt*rlmo
      zetau=zu*rlmo
      zetat=zt*rlmo
!
      zetalu=min(max(zetalu,ztmin1),ztmax1)
      zetalt=min(max(zetalt,ztmin1),ztmax1)
      zetau=min(max(zetau,ztmin1/rzsu),ztmax1/rzsu)
      zetat=min(max(zetat,ztmin1/rzst),ztmax1/rzst)
!--------------water functions------------------------------------------
      rz=(zetau-ztmin1)/dzeta1
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0)
      psmz=(psim1(k+2)-psim1(k+1))*rdzt+psim1(k+1)
!
      rz=(zetalu-ztmin1)/dzeta1
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0)
      psmzl=(psim1(k+2)-psim1(k+1))*rdzt+psim1(k+1)
!
      simm=psmzl-psmz+rlogu
!
      rz=(zetat-ztmin1)/dzeta1
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0)
      pshz=(psih1(k+2)-psih1(k+1))*rdzt+psih1(k+1)
!
      rz=(zetalt-ztmin1)/dzeta1
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0    )
      pshzl=(psih1(k+2)-psih1(k+1))*rdzt+psih1(k+1)
!
      simh=(pshzl-pshz+rlogt)*fh01
!-----------------------------------------------------------------------
      ustark=ustar*vkrm
      akms=max(ustark/simm,cxchs)
      akhs=max(ustark/simh,cxchs)
!--------------beljaars correction for ustar----------------------------
      wstar2=wwst2*abs(btgh*akhs*dthv)**(2./3.)
      ustar=max(sqrt(akms*sqrt(du2+wstar2)),epsust)
!-----------------------------------------------------------------------
!          endif  !  end of turbulent branch
!-----------------------------------------------------------------------
          enddo  !  end of the iteration loop over sea points
!-----------------------------------------------------------------------
                      else  !  land points
!-----------------------------------------------------------------------
      zu=z0
      uz0=0.
      vz0=0.
!
      zt=zu*ztfc
      thz0=ths
!
      zq=zt
      qz0=qs
!-----------------------------------------------------------------------
      tem=(tlm+tz0)*0.5
      thm=(thvlm+thz0)*0.5
!
      a=thm*0.608
      b=(elocp/tem-1.608)*thm
!
      dthv=((thvlm-thz0)*((qlm+qz0)*(0.5*0.608)+1.)
     &     +(qlm-qz0)*a
     &     +clm*b)
!
      du2=max((ulm-uz0)**2+(vlm-vz0)**2,epsu2)
      rib=btg*dthv*zsl/du2
!-----------------------------------------------------------------------
!          if(rib.ge.ric)then
!      akms=max( visc*rdz,cxchl)
!      akhs=max(tvisc*rdz,cxchl)
!-----------------------------------------------------------------------
!          else  !  turbulent branch
!-----------------------------------------------------------------------
      zslu=zsl+zu
      zslt=zsl+zt
!
      rzsu=zslu/zu
!
      rlogu=log(rzsu)
!-----------------------------------------------------------------------
          do itr=1,itrmx
!--------------zilitinkevitch fix for zt--------------------------------
      zt=max(exp(zilfc*sqrt(ustar*zu))*zu,epszt)
!zj      zt=exp(zilfc*sqrt(ustar*zu))*zu
      rzst=zslt/zt
      rlogt=log(rzst)
!--------------1./monin-obukkhov length-scale---------------------------
      rlmo=elfc*akhs*dthv/ustar**3
      zetalu=zslu*rlmo
      zetalt=zslt*rlmo
      zetau=zu*rlmo
      zetat=zt*rlmo
!
      zetalu=min(max(zetalu,ztmin2),ztmax2)
      zetalt=min(max(zetalt,ztmin2),ztmax2)
      zetau=min(max(zetau,ztmin2/rzsu),ztmax2/rzsu)
      zetat=min(max(zetat,ztmin2/rzst),ztmax2/rzst)
!--------------land functions-------------------------------------------
      rz=(zetau-ztmin2)/dzeta2
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0)
      psmz=(psim2(k+2)-psim2(k+1))*rdzt+psim2(k+1)
!
      rz=(zetalu-ztmin2)/dzeta2
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0)
      psmzl=(psim2(k+2)-psim2(k+1))*rdzt+psim2(k+1)
!
      simm=psmzl-psmz+rlogu
!
      rz=(zetat-ztmin2)/dzeta2
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0    )
      pshz =(psih2(k+2)-psih2(k+1))*rdzt+psih2(k+1)
!
      rz=(zetalt-ztmin2)/dzeta2
      k=int(rz)
      rdzt=rz-float(k)
      k=min(k,kztm2)
      k=max(k,0    )
      pshzl=(psih2(k+2)-psih2(k+1))*rdzt+psih2(k+1)
!
      simh=(pshzl-pshz+rlogt)*fh02
!-----------------------------------------------------------------------
      ustark=ustar*vkrm
      akms=max(ustark/simm,cxchl)
      akhs=max(ustark/simh,cxchl)
!--------------beljaars correction for ustar----------------------------
      wstar2=wwst2*abs(btgh*akhs*dthv)**(2./3.)
      ustar=max(sqrt(akms*sqrt(du2+wstar2)),epsust)
!-----------------------------------------------------------------------
          enddo  !  end of iteration for land points
!-----------------------------------------------------------------------
!          endif  !  end of turbulant branch over land
!-----------------------------------------------------------------------
                  endif  !  end of land/sea branch
!--------------countergradient fix--------------------------------------
!      hv=-akhs*dthv
!          if(hv.gt.0.)then
!      fct=-10.*(btg)**(-1./3.)
!      ct=fct*(hv/(hpbl*hpbl))**(2./3.)
!          else
      ct=0.
!          endif
!--------------diagnostic block-----------------------------------------
      wstar=sqrt(wstar2)/wwst
!
      umflx=akms*(ulm -uz0 )
      vmflx=akms*(vlm -vz0 )
      hsflx=akhs*(thlm-thz0)
      hlflx=akhs*(qlm -qz0 )
!-----------------------------------------------------------------------
!      if(rib.ge.ric) then
!-----------------------------------------------------------------------
!        if(sm.gt.0.) then
!          akms10=max( visc/10.,cxchs)
!          akhs02=max(tvisc/02.,cxchs)
!          akhs10=max(tvisc/10.,cxchs)
!        else
!          akms10=max( visc/10.,cxchl)
!          akhs02=max(tvisc/02.,cxchl)
!          akhs10=max(tvisc/10.,cxchl)
!        endif
!-----------------------------------------------------------------------
!      else
!-----------------------------------------------------------------------
        zu10=zu+10.
        zt02=zt+02.
        zt10=zt+10.
!
        rlnu10=log(zu10/zu)
        rlnt02=log(zt02/zt)
        rlnt10=log(zt10/zt)
!
        ztau10=zu10*rlmo
        ztat02=zt02*rlmo
        ztat10=zt10*rlmo
!--------------sea------------------------------------------------------
        if(sm.gt.0.)then
!-----------------------------------------------------------------------
          ztau10=min(max(ztau10,ztmin1),ztmax1)
          ztat02=min(max(ztat02,ztmin1),ztmax1)
          ztat10=min(max(ztat10,ztmin1),ztmax1)
!-----------------------------------------------------------------------
          rz=(ztau10-ztmin1)/dzeta1
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psm10=(psim1(k+2)-psim1(k+1))*rdzt+psim1(k+1)
!
          simm10=psm10-psmz+rlnu10
!
          rz=(ztat02-ztmin1)/dzeta1
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psh02=(psih1(k+2)-psih1(k+1))*rdzt+psih1(k+1)
!
          simh02=(psh02-pshz+rlnt02)*fh01
!
          rz=(ztat10-ztmin1)/dzeta1
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psh10=(psih1(k+2)-psih1(k+1))*rdzt+psih1(k+1)
!
          simh10=(psh10-pshz+rlnt10)*fh01
!
          akms10=max(ustark/simm10,cxchs)
          akhs02=max(ustark/simh02,cxchs)
          akhs10=max(ustark/simh10,cxchs)
!--------------land-----------------------------------------------------
        else
!-----------------------------------------------------------------------
          ztau10=min(max(ztau10,ztmin2),ztmax2)
          ztat02=min(max(ztat02,ztmin2),ztmax2)
          ztat10=min(max(ztat10,ztmin2),ztmax2)
!-----------------------------------------------------------------------
          rz=(ztau10-ztmin2)/dzeta2
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psm10=(psim2(k+2)-psim2(k+1))*rdzt+psim2(k+1)
!
          simm10=psm10-psmz+rlnu10
!
          rz=(ztat02-ztmin2)/dzeta2
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psh02=(psih2(k+2)-psih2(k+1))*rdzt+psih2(k+1)
!
          simh02=(psh02-pshz+rlnt02)*fh02
!
          rz=(ztat10-ztmin2)/dzeta2
          k=int(rz)
          rdzt=rz-float(k)
          k=min(k,kztm2)
          k=max(k,0    )
          psh10=(psih2(k+2)-psih2(k+1))*rdzt+psih2(k+1)
!
          simh10=(psh10-pshz+rlnt10)*fh02
!
          akms10=max(ustark/simm10,cxchl)
          akhs02=max(ustark/simh02,cxchl)
          akhs10=max(ustark/simh10,cxchl)
!-----------------------------------------------------------------------
        endif
!-----------------------------------------------------------------------
!      endif
!-----------------------------------------------------------------------
      u10 =umflx/akms10+uz0
      v10 =vmflx/akms10+vz0
      th02=hsflx/akhs02+thz0
      th10=hsflx/akhs10+thz0
      q02 =hlflx/akhs02+qz0
      q10 =hlflx/akhs10+qz0
!-----------------------------------------------------------------------
                           return
                           end
!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      subroutine psitbl
!     ******************************************************************
!     *                                                                *
!     *               surface layer integral functions                 *
!     *               responsible person: z.janjic                     *
!     *                                                                *
!     ******************************************************************
!-----------------------------------------------------------------------
      parameter(pihf=3.14159265/2.,eps=0.000001)
!-----------------------------------------------------------------------
      include "psi.comm"
!***********************************************************************
      fh01=1.
      fh02=1.
!
      ztmin1=-10.0
      ztmax1=2.0
!
      ztmin2=-10.0
      ztmax2=2.0
!
      zrng1=ztmax1-ztmin1
      zrng2=ztmax2-ztmin2
!
      dzeta1=zrng1/(kztm-1)
      dzeta2=zrng2/(kztm-1)
!--------------function definition loop---------------------------------
      zeta1=ztmin1
      zeta2=ztmin2
          do 100 k=1,kztm
!--------------unstable range-------------------------------------------
      if(zeta1.lt.0.)then
!--------------paulson 1970 functions-----------------------------------
        x=sqrt(sqrt(1.-16.*zeta1))
!
        psim1(k)=-2.*log((x+1.)/2.)-log((x*x+1.)/2.)+2.*atan(x)-pihf
        psih1(k)=-2.*log((x*x+1.)/2.)
!--------------stable range---------------------------------------------
      else
!--------------paulson 1970 functions-----------------------------------
!        psim1(k)=5.*zeta1
!        psih1(k)=5.*zeta1
!--------------holtslag and de bruin 1988-------------------------------
        psim1(k)=0.7*zeta1+0.75*zeta1*(6.-0.35*zeta1)*exp(-0.35*zeta1)
        psih1(k)=0.7*zeta1+0.75*zeta1*(6.-0.35*zeta1)*exp(-0.35*zeta1)
!-----------------------------------------------------------------------
      endif
!--------------unstable range-------------------------------------------
      if(zeta2.lt.0.)then
!--------------paulson 1970 functions-----------------------------------
        x=sqrt(sqrt(1.-16.*zeta2))
!
        psim2(k)=-2.*log((x+1.)/2.)-log((x*x+1.)/2.)+2.*atan(x)-pihf
        psih2(k)=-2.*log((x*x+1.)/2.)
!--------------stable range---------------------------------------------
      else
!--------------paulson 1970 functions-----------------------------------
!        psim2(k)=5.*zeta2
!        psih2(k)=5.*zeta2
!--------------holtslag and de bruin 1988-------------------------------
        psim2(k)=0.7*zeta2+0.75*zeta2*(6.-0.35*zeta2)*exp(-0.35*zeta2)
        psih2(k)=0.7*zeta2+0.75*zeta2*(6.-0.35*zeta2)*exp(-0.35*zeta2)
!-----------------------------------------------------------------------
      endif
!-----------------------------------------------------------------------
      if(k.eq.kztm)then
        ztmax1=zeta1
        ztmax2=zeta2
      endif
!
      zeta1=zeta1+dzeta1
      zeta2=zeta2+dzeta2
!-----------------------------------------------------------------------
 100  continue
!-----------------------------------------------------------------------
      ztmax1=ztmax1-eps
      ztmax2=ztmax2-eps
!-----------------------------------------------------------------------
      return
      end
