      SUBROUTINE COLLECT_DUM ( A,DUM ) 
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    COLLECT     GATHERS FROM ALL MPI TASKS
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     GATHER "A" FROM ALL MPI TASKS ONTO TASK 0
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C   01-01-03  T BLACK - MODIFIED FROM ETA POST-PROCESSOR
C
C USAGE:    CALL COLLECT_DUM(A,DUM)
C   INPUT ARGUMENT LIST:
C     A        - ARRAY BEING GATHERED
C
C   OUTPUT ARGUMENT LIST:
C     DUM      - GATHERED ARRAY 
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_GATHERV
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MPI_PARM.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : IBM RS/6000 SP
C$$$
C----------------------------------------------------------------------
      INCLUDE "parmeta.resout"
      INCLUDE 'mpif.h'
C----------------------------------------------------------------------
      INCLUDE "MPI_PARM.comm"
C----------------------------------------------------------------------
      PARAMETER(IM=IMO,JM=JMO)
      REAL A(IM,JM) 
      REAL DUM(IM,JM) 
C----------------------------------------------------------------------
      INTEGER I,J
      INTEGER IERR
C----------------------------------------------------------------------
C
Cwas      IF(NUM_PROCS.EQ.1)RETURN
C
      CALL MPI_GATHERV(A(1,JSTA),ICNT(MYPE),MPI_REAL,
     1    DUM,ICNT,IDSP,MPI_REAL,0,MPI_COMM_WORLD,IERR)
C
      END               
