@PROCESS NOCHECK
      SUBROUTINE EXCH3D(A)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    EXCH        EXCHANGE ONE HALO ROW
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     EXCHANGE ONE HALO ROW
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C   01-01-03  T BLACK - MODIFIED FROM ETA POST-PROCESSOR
C
C USAGE:    CALL EXCH(A)
C   INPUT ARGUMENT LIST:
C      A - ARRAY TO HAVE HALOS EXCHANGED
C
C   OUTPUT ARGUMENT LIST:
C      A - ARRAY WITH HALOS EXCHANGED
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_SENDRECV
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON - MPI_PARM.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
C----------------------------------------------------------------------
      INCLUDE "parmeta.resout"
      INCLUDE "parmeta.resin"
      INCLUDE "mpif.h"
C----------------------------------------------------------------------
      INCLUDE "MPI_PARM.comm"
      PARAMETER(IM=IMO,JM=JMO)
C----------------------------------------------------------------------
      REAL A(IMO,JMO,LMI)
      INTEGER STATUS(MPI_STATUS_SIZE)
C----------------------------------------------------------------------
C    
      IF(NUM_PROCS.EQ.1)RETURN
C
      DO L=1,LMI
      CALL MPI_SENDRECV(A(1,JEND,L),IM,MPI_REAL,IUP,1,
     1                  A(1,JSTA-1,L),IM,MPI_REAL,IDN,1,
     2                  MPI_COMM_WORLD,STATUS,IERR)
C
c      print*,'done calling first sendreceive in exch3d'
      IF(IERR.NE.0)THEN
        PRINT*, ' problem with first sendrecv in exch, ierr = ',IERR
        CALL MPI_ABORT(MPI_COMM_WORLD,1,IERR)
      ENDIF
C
      CALL MPI_SENDRECV(A(1,JSTA,L),IM,MPI_REAL,IDN,1,
     1                  A(1,JEND+1,L),IM,MPI_REAL,IUP,1,
     2                  MPI_COMM_WORLD,STATUS,IERR)
C
c      print*,'done calling second sendreceive in exch3d'
      IF(IERR.NE.0)THEN
        PRINT*, ' problem with second sendrecv in exch, ierr = ',IERR
        CALL MPI_ABORT(MPI_COMM_WORLD,1,IERR)
      ENDIF
      END DO
C
      END
