c
      SUBROUTINE G2T2V(ALAT,ALON,KB
     1,                IM,JM,TPH0D,TLM0D,DPHD,DLMD
     2,                II,JJ)
C-----------------------------------------------------------------
      include "mpif.h"
      INCLUDE "MPI_PARM.comm"
      PARAMETER (D2R=1.74532925E-2,R2D=1./D2R)
C-----------------------------------------------------------------
        real(8) DLM1,DLM2,TLAT1,TLON1,TLAT2,TLON2,TLAT,D1,D2
      IMT=2*IM-1
      JMT=JM/2+1
      WBD=-(IM-1)*DLMD
      SBD=-(JM/2)*DPHD
      SLP0=DPHD/DLMD
C***
C***  CONVERT FROM GEODETIC TO TRANSFORMED COORDINATES (DEGREES)
C***
      GLAT=ALAT*D2R
      GLON=ALON*D2R
      DPH=DPHD*D2R
      DLM=DLMD*D2R
      TPH0=TPH0D*D2R
      TLM0=TLM0D*D2R
      WB=WBD*D2R
      SB=SBD*D2R
C
      X=COS(TPH0)*COS(GLAT)*COS(GLON-TLM0)+SIN(TPH0)*SIN(GLAT)
      Y=-COS(GLAT)*SIN(GLON-TLM0)
      Z=COS(TPH0)*SIN(GLAT)-SIN(TPH0)*COS(GLAT)*COS(GLON-TLM0)
      TLAT=R2D*ATAN(Z/SQRT(X*X+Y*Y))
      TLON=R2D*ATAN(Y/X)
      ALAT=TLAT*D2R
      ALON=TLON*D2R
C
C     WRITE(0,25)TLAT,TLON
   25 FORMAT(' TRANSFORMED LATITUDE IS',F8.3
     1,               4X,'LONGITUDE IS',F8.3)
C***
C***  IDENTIFY THE ROW AND COLUMN OF THE LOWER LEFT CORNER OF THE BOX
C***  THAT SURROUNDS THE GIVEN GEODETIC LOCATION
C***
      ROW=TLAT/DPHD+JMT
      COL=TLON/DLMD+IM
      NROW=INT(ROW)
      NCOL=INT(COL)
      TLAT=TLAT*D2R
      TLON=TLON*D2R
C***
C***  FIRST CONSIDER THE SITUATION WHERE THE POINT X IS AT
C***
C***              H      V
C***
C***
C***                 X
C***              V      H
C***
      IF(MOD(NROW,2).EQ.0.AND.MOD(NCOL,2).EQ.1.OR.
     1   MOD(NROW,2).EQ.1.AND.MOD(NCOL,2).EQ.0)THEN
        TLAT1=(NROW-JMT)*DPH
        TLAT2=TLAT1+DPH
        TLON1=(NCOL-IM)*DLM
        TLON2=TLON1+DLM
        DLM1=TLON-TLON1
        DLM2=TLON-TLON2
        D1=ACOS(COS(TLAT)*COS(TLAT1)*COS(DLM1)+SIN(TLAT)*SIN(TLAT1))
        D2=ACOS(COS(TLAT)*COS(TLAT2)*COS(DLM2)+SIN(TLAT)*SIN(TLAT2))
c      D1=DACOS(DCOS(TLAT)*DCOS(TLAT1)*DCOS(DLM1)+DSIN(TLAT)*DSIN(TLAT1))
c      D2=DACOS(DCOS(TLAT)*DCOS(TLAT2)*DCOS(DLM2)+DSIN(TLAT)*DSIN(TLAT2))
        IF(D1.GT.D2)THEN
          NROW=NROW+1
          NCOL=NCOL+1
        ENDIF
C***
C***  NOW CONSIDER THE SITUATION WHERE THE POINT X IS AT
C***
C***              V      H
C***
C***
C***                 X
C***              H      V
C***
      ELSE
        TLAT1=(NROW+1-JMT)*DPH
        TLAT2=TLAT1-DPH
        TLON1=(NCOL-IM)*DLM
        TLON2=TLON1+DLM
        DLM1=TLON-TLON1
        DLM2=TLON-TLON2
        D1=ACOS(COS(TLAT)*COS(TLAT1)*COS(DLM1)+SIN(TLAT)*SIN(TLAT1))
        D2=ACOS(COS(TLAT)*COS(TLAT2)*COS(DLM2)+SIN(TLAT)*SIN(TLAT2))
c      D1=DACOS(DCOS(TLAT)*DCOS(TLAT1)*DCOS(DLM1)+DSIN(TLAT)*DSIN(TLAT1))
c      D2=DACOS(DCOS(TLAT)*DCOS(TLAT2)*DCOS(DLM2)+DSIN(TLAT)*DSIN(TLAT2))
        IF(D1.LT.D2)THEN
          NROW=NROW+1
        ELSE
          NCOL=NCOL+1
        ENDIF
      ENDIF
      JJ=NROW
      II=NCOL/2
      IF(MOD(JJ,2) .EQ. 0) II=II+1
C***
C***  NOW WE CAN FIND THE K VALUE
C***
      KROWS=((NROW-1)/2)*IMT
      IF(MOD(NROW,2).EQ.1)THEN
        K=KROWS+NCOL/2
      ELSE
        K=KROWS+IM-1+(NCOL+1)/2
      ENDIF
C     WRITE(6,20)II,JJ,K
   20 FORMAT(' KI=',2I3,' NEAREST VELOCITY POINT AT K=',I5)
C
  100 CONTINUE
C
      RETURN
      END
