      SUBROUTINE ICOLLECT_LOC ( IA,IDUM ) 
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    ICOLLECT    GATHERS FROM ALL MPI TASKS
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     GATHER "IA" FROM ALL MPI TASKS ONTO TASK 0
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C   01-01-03  T BLACK - MODIFIED FROM ETA POST-PROCESSOR
C
C USAGE:    CALL ICOLLECT_DUM(IA,IDUM)
C   INPUT ARGUMENT LIST:
C     IA       - ARRAY BEING GATHERED
C
C   OUTPUT ARGUMENT LIST:
C     IDUM     - GATHERED ARRAY 
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C       MPI_GATHERV
C     UTILITIES:
C       NONE
C     LIBRARY:
C       COMMON   - MPI_PARM.comm
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN 90
C     MACHINE : IBM RS/6000 SP
C$$$
C----------------------------------------------------------------------
      INCLUDE "parmeta.resout"
      INCLUDE 'mpif.h'
C----------------------------------------------------------------------
      INCLUDE "MPI_PARM.comm"
C----------------------------------------------------------------------
       PARAMETER(IM=IMO,JM=JMO)
      INTEGER IA(IM,JSTA:JEND) 
      INTEGER IDUM(IM,JM) 
C----------------------------------------------------------------------
      INTEGER I,J
      INTEGER IERR
C----------------------------------------------------------------------
C
      IF(NUM_PROCS.EQ.1)RETURN
C
      CALL MPI_GATHERV(IA(1,JSTA),ICNT(MYPE),MPI_INTEGER,
     1    IDUM,ICNT,IDSP,MPI_INTEGER,0,MPI_COMM_WORLD,IERR)
C
      END               
