      SUBROUTINE PARA_RANGE (N1,N2,NPROCS,IRANK,JSTA,JEND)
C$$$  SUBPROGRAM DOCUMENTATION BLOCK
C                .      .    .
C SUBPROGRAM:    PARA_RANGE  SET UP DECOMPOSITION VALUES
C   PRGRMMR: TUCCILLO        ORG: IBM
C
C ABSTRACT:
C     SETS UP DECOMOSITION VALUES
C   .
C
C PROGRAM HISTORY LOG:
C   00-01-06  TUCCILLO - ORIGINAL
C   01-01-03  T BLACK - MODIFIED FROM THE ETA POST-PROCESSOR
C
C USAGE:    CALL COLLECT(A)
C   INPUT ARGUMENT LIST:
C     N1 - FIRST INTERATE VALUE
C     N2 - LAST INTERATE VALUE
C     NPROCS - NUMBER OF MPI TASKS
C     IRANK - MY TAKS ID
C
C   OUTPUT ARGUMENT LIST:
C     JSTA - FIRST LOOP VALUE
C     JEND - LAST LOOP VALUE
C
C   OUTPUT FILES:
C     STDOUT  - RUN TIME STANDARD OUT.
C
C   SUBPROGRAMS CALLED:
C     UTILITIES:
C       NONE
C     LIBRARY:
C
C   ATTRIBUTES:
C     LANGUAGE: FORTRAN
C     MACHINE : IBM RS/6000 SP
C$$$
C------------------------------------------------------------------
      IMPLICIT NONE
C------------------------------------------------------------------
      INTEGER N1,N2,NPROCS,IRANK,JSTA,JEND
      INTEGER IWORK1,IWORK2
C------------------------------------------------------------------
      IWORK1=(N2-N1+1)/NPROCS
      IWORK2=MOD(N2-N1+1,NPROCS)
      JSTA=IRANK*IWORK1+N1+MIN(IRANK,IWORK2)
      JEND=JSTA+IWORK1-1
      IF(IWORK2.GT.IRANK)JEND=JEND+1
C------------------------------------------------------------------
C
      END

