      SUBROUTINE READSFC
C     ******************************************************************
                             P A R A M E T E R
     & (D00=0.0,D5=5.E-1,D01=1.00E-2,H1=1.0,HM1=-1.0
     &, H90=90.0,H360=360.0,EPS=1.E-10)
C----------------------------------------------------------------------
      integer,parameter::real_32=selected_real_kind(6,30)
      INCLUDE "parmeta.resout"
      INCLUDE "parmsoil"
      INCLUDE "mpif.h"
      INCLUDE "MPI_PARM.comm"
C----------------------------------------------------------------------
                             P A R A M E T E R
     & (ITB=076,JTB=134,ITBQ=152,JTBQ=440)
                             P A R A M E T E R
     & (IM=IMO,JM=JMO,LM=LMO,KB=2*IMO+JMO-3,LMOP=LMO+1)
C-----------------------------------------------------------------------
                             C O M M O N  /SFCFLDS/
     & SST(IM,JM),ALBEDO(IM,JM),SI(IM,JM),SNO(IM,JM),SMC(IM,JM,NSOIL)
     &,STC(IM,JM,NSOIL),CMC(IM,JM)
c
                             C O M M O N /OUTETA/
     1 PDO(IMO,JMO),PDB(KB,2)
cc     2,TO(IMO,JSTA:JEND,LMO),QO(IMO,JSTA:JEND,LMO)
cc     3,UO(IMO,JSTA:JEND,LMO),VO(IMO,JSTA:JEND,LMO)
cc     4,CWMO(IMO,JSTA:JEND,LMO),Q2O(IMO,JSTA:JEND,LMO)
     5,TB (KB,LMO,2),QB (KB,LMO,2),UB (KB,LMO,2),VB (KB,LMO,2)
     6,PT,DETAO(LMO),AETAO(LMO),ETAO(LMOP),DFLO(LMOP)
     7,SM(IMO,JMO),RESO(IMO,JMO),FISO(IMO,JMO)
C-----------------------------------------------------------------------
                             C O M M O N /MASKS/
     & HBM2  (IM,JM),VBM2  (IM,JM),VBM3  (IM,JM),SICE (IM,JM)
C-----------------------------------------------------------------------
       COMMON /LATLONS/
     & HLATO(IMO,JMO),HLONO(IMO,JMO),VLATO(IMO,JMO),VLONO(IMO,JMO)
     & ,ihinx(imo,jmo),ihiny(imo,jmo),ivinx(imo,jmo),iviny(imo,jmo)
     & ,ih2hx(imo,jmo),ih2hy(imo,jmo),wh(imo,jmo,4),wv(imo,jmo,4)
C-----------------------------------------------------------------------
       COMMON /TGRND/ TG(IM,JM)
C
                             D I M E N S I O N
     &  IGDATE(4)
C
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:)::GLATS,SLAT,WLAT
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:)::GGTG,GGSLI,GGRID1
       REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:,:)::GGSMC2,GGSTC2
C
cc       real SMCG(IM,JM,NSOIL),STCG(IM,JM,NSOIL)
       CHARACTER*32 GLABEL
C-----------------------------------------------------------------------
      DPR=180./3.141592654
C
      READ (33) 
      READ (33) GFHR,IGDATE,NGLONS,NGLATS,NUM
      if(mype.eq.0) then
       print *,' nglats,nglons = ',gfhr,igdate,nglats,nglons,num
      endif
C
      ALLOCATE(GGRID1(NGLONS,NGLATS))
      ALLOCATE(GLATS(NGLATS))
      ALLOCATE(SLAT(NGLATS))
      ALLOCATE(WLAT(NGLATS))
      ALLOCATE(GGSMC2(NGLONS,NGLATS,2))
      ALLOCATE(GGSTC2(NGLONS,NGLATS,2))
      ALLOCATE(GGTG(NGLONS,NGLATS))
      ALLOCATE(GGSLI(NGLONS,NGLATS))
C
C READ GLOBAL GAUSSIAN FIELDS FROM THE BGES FILE AND INTERPOLATE THEM TO
C THE ETA GRID
C FIRST CALCULATE THE GAUSSIAN LATITUDES
C
      CALL SPLAT(4,NGLATS,SLAT,WLAT)
      DO J = 1, NGLATS
        GLATS(J) = DPR*ASIN(SLAT(J))
      ENDDO 
C
C NOW READ IN THE FIELDS, NOTE WE NEED THE GLOBAL SEA,LAND ICE MASK
C TO DO A PROPER INTERPOLATION.
C FIRST TWO RECORDS NOW READ IN ECONVK
c     OPEN(33,FILE='fort.33',
c    &     FORM='UNFORMATTED',STATUS='OLD',IOSTAT=IRET)
C
      if(mype.eq.0)print *,'ok after gfhr in sfcanl'
C  BYPASS THE SURFACE TEMPERATURE RECORD
      READ (33) GGRID1
      if(mype.eq.0)print *,'ok after rec 1 in sfcanl'
C  READ AND SAVE THE TWO-LAYER SOIL MOISTURE RECORDS
      READ (33) GGSMC2
      if(mype.eq.0)print *,'ok after rec 2 in sfcanl'
C  BYPASS THE SNOW DEPTH RECORD
      READ (33) GGRID1
      if(mype.eq.0)print *,'ok after rec 3 in sfcanl'
C  READ AND STORE THE THE SOIL TEMPERATURES (TWO-LAYERS)
      READ (33) GGSTC2
      if(mype.eq.0)print *,'ok after rec 4 in sfcanl'
C  READ AND STORE THE DEEP LAYER SOIL TEMPERATURE
      READ (33) GGTG
      if(mype.eq.0)print *,'ok after rec 5 in sfcanl'
C  BYPASS 5 MORE RECORDS AND THEN READ AND STORE THE SEA,LAND ICE RECORD
C  BYPASSING Z0,CONV. CLD FRACT.,CONV. CLD BASE,CONV CLD TOP, AND ALBEDO
      DO KRD = 1,6
      READ (33) GGSLI
      END DO
      if(mype.eq.0)print *,'ok after rec 6-12 in sfcanl'
C
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSMC2(1,1,1),SMC(1,1,1))
      if(mype.eq.0)print*,'just called GAUTOETA for smc'
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSTC2(1,1,1),STC(1,1,1))
      if(mype.eq.0)print*,'just called GAUTOETA for stc'
      CALL GAUTOICE(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSTC2(1,1,1),STC(1,1,1))
      if(mype.eq.0)print*,'just called GAUTOETA for stc'
      DO KK=2,NSOIL
       CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSMC2(1,1,2),SMC(1,1,KK))
       if(mype.eq.0)print*,'just called GAUTOETA for smc'
       CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSTC2(1,1,2),STC(1,1,KK))
       if(mype.eq.0)print*,'just called GAUTOETA for stc'
       CALL GAUTOICE(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGSTC2(1,1,2),STC(1,1,KK))
       if(mype.eq.0)print*,'just called GAUTOETA for stc'
      ENDDO
CC ASSIGN GLOBAL STC SMC TO SIGMA STC AND SMC AT EVERYGRID POINT
cc      DO K=1,NSOIL
cc       DO J=JSTA,JEND
cc        DO I=1,IM
cc	 SMC(I,J,K)=SMCG(I,J,K)
cc	 STC(I,J,K)=STCG(I,J,K)
cc	END DO
cc       END DO
cc      END DO 	 
C
C NOW SET LOWER BOUNDARY CONDITION ON SUB-SURFACE
C TEMPERATURE, TREAT UNDER SEA-ICE AFTER CALL
      CALL GAUTOETA(GLATS,NGLATS,NGLONS,HLATO,HLONO,SM,SICE,GGSLI,
     &              GGTG,TG)
c      do j=jsta,jend
c       do i=1,im
c        print*,'tg',i,j,tg(i,j)
c       end do
c      end do
      if(mype.eq.0)print*,'just called GAUTOETA for tg'
C
      DEALLOCATE(GGRID1)
      DEALLOCATE(SLAT)
      DEALLOCATE(WLAT)
      DEALLOCATE(GLATS)
      DEALLOCATE(GGSMC2)
      DEALLOCATE(GGSTC2)
      DEALLOCATE(GGTG)
      DEALLOCATE(GGSLI)
C-----------------------------------------------------------------------
                             RETURN
                             END
