      SUBROUTINE SFCEDAS
C**********************************************************************
                             P A R A M E T E R
     & (D00=0.0,D5=5.E-1,D01=1.00E-2,H1=1.0,HM1=-1.0
     &, H90=90.0,H360=360.0,EPS=1.E-10,EPSLL=1.E-04)
C----------------------------------------------------------------------
C Parameter used in cold start SH2O initialization
      PARAMETER (NSOTYP=9)
C----------------------------------------------------------------------
      integer,parameter::real_32=selected_real_kind(6,30)
C-----------------------------------------------------------------------
C                            I N C L U D E S
C DEFINE TARGET ETA GRID THAT THIS GRDETA EXECUTE CREATES
      include "parmeta.resout"
      include "parmsoil"
C DEFINE GRID OF INPUT ETA RESTART FILE
      include "parmeta.resin"
      include "griddef.in"
      INCLUDE "mpif.h"
      INCLUDE "MPI_PARM.comm"
c
CC IMI,JMI are dims of parent domain
CC
CC IM,JM are dims for the target (nest) domain
CC
C----------------------------------------------------------------------
                             P A R A M E T E R
     & (IM=IMO,JM=JMO,LM=LMO,LP1=LM+1,KB=JM+2*IM-3)
C----------------------------------------------------------------------
                             P A R A M E T E R
     & (ITB=076,JTB=134,ITBQ=152,JTBQ=440)
C----------------------------------------------------------------------
                             C O M M O N /OUTETA/
     1 PDO(IM,JM)
     4,PDB(KB,2)
     5,TB (KB,LMO,2),QB (KB,LMO,2),UB (KB,LMO,2),VB (KB,LMO,2)
     6,PT,DETA(LMO),AETA(LMO),ETA(LMO+1),DFL(LMO+1),SM(IM,JM)
     7,RES(IM,JM),FIS(IM,JM)
C
                             C O M M O N  /SFCFLDS/
     & SST(IM,JM),ALBEDO(IM,JM),SI(IM,JM),SNO(IM,JM),SMC(IM,JM,NSOIL)
     &,STC(IM,JM,NSOIL),CMC(IM,JM)
      COMMON /NEWSFCFLDS/ SH2O(IMO,JMO,NSOIL)
      COMMON /TGRND/ TG(IM,JM)
c
C-----------------------------------------------------------------------
C-----------------------------------------------------------------------
                             C O M M O N /MASKS/
     & HBM2(IM,JM),VBM2(IM,JM),VBM3  (IM,JM),SICE(IM,JM)
C-----------------------------------------------------------------------
                             C O M M O N /LATLONS/
     & HLAT(IM,JM),HLON(IM,JM),VLAT(IM,JM),VLON(IM,JM)
     & ,ihinx(imo,jmo),ihiny(imo,jmo),ivinx(imo,jmo),iviny(imo,jmo)
     & ,ih2hx(imo,jmo),ih2hy(imo,jmo),wh(imo,jmo,4),wv(imo,jmo,4)
C-----------------------------------------------------------------------
                             C O M M O N  /SFCTYPES/
     & IVGTPK(IM,JM),ISLTPK(IM,JM),ISPTPK(IM,JM)
C-----------------------------------------------------------------------
                             D I M E N S I O N
     & IDATE(4),IDATI(3),DUM12D(ITB,JTB),DUM22D(ITB,JTB)
     &,HGTE(IMI,JMI),HGTH(IMO,JMO)
C 
c     REAL(REAL_32) SMC(IM,JM,4),STC(IM,JM,4),CMC(IM,JM)

      REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:)::SMI,SICEI
      REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:,:)::SMCI,STCI,SH2OI
      REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:)::CMCI
c      REAL(REAL_32),ALLOCATABLE,DIMENSION(:,:)::IVGTPKI,ISLTPKI,ISPTPKI
C-----------------------------------------------------------------------
C COMMENTED BLOCK BELOW IS FORMER NON-DYNAMIC MEMORY ALLOCATION
                             D I M E N S I O N
     & IVGTPKI(IMI,JMI),ISLTPKI(IMI,JMI),ISPTPKI(IMI,JMI)
c     &,SMI(IMI,JMI),SICEI(IMI,JMI)
c     &,SMCI(IMI,JMI,NSOIL),STCI(IMI,JMI,NSOIL),CMCI(IMI,JMI)
C-----------------------------------------------------------------------
C Soil parameter arrays used in cold start SH2O initialization
      DIMENSION PSIS(NSOTYP),BETA(NSOTYP),SMCMAX(NSOTYP)
C-----------------------------------------------------------------------
                             D A T A
Corig     & NHIBUI/34/, NRESTRTI/36/, LDATE/52/
     & NHIBUI/34/, NRESTRTI/11/, LDATE/52/
     &,RADLAT /1./
C-----------------------------------------------------------------------
C Constants used in cold start SH2O initialization
      DATA HLICE/3.335E5/,GRAV/9.81/,T0/273.15/
      DATA BLIM/5.5/
      DATA PSIS /0.04,0.62,0.47,0.14,0.10,0.26,0.14,0.36,0.04/
      DATA BETA /4.26,8.72,11.55,4.74,10.73,8.17,6.77,5.25,4.26/
      DATA SMCMAX /0.421,0.464,0.468,0.434,0.406,
     &             0.465,0.404,0.439,0.421/
C-----------------------------------------------------------------------
C
	REWIND NRESTRTI

      READ(NRESTRTI) DUM,IDATI,IHRSTI
C
C READ DATE AND HOUR
c      REWIND LDATE
c      READ(LDATE) IDATE
c      IHRST=IDATE(1)
C CHECK THAT VAILD DATE/TIME OF INPUT RESTART FILE MATCHES EXPECTED DATE/TIME
c      IF ( (IHRST .NE. IHRSTI) .OR. (IDAT(1) .NE. IDATI(1)) .OR.
c     1     (IDAT(2) .NE. IDATI(2)) .OR. (IDAT(3) .NE. IDATI(3)) ) THEN
c        PRINT *,'MIS-MATCH WITH INPUT EDAS DATE/TIME - STOP EXECUTION'
c        PRINT *,IHRST,IHRSTI,IDAT(1),IDATI(1),IDAT(2),IDATI(2),
c     1     IDAT(3),IDATI(3)
c       STOP 886
c      ENDIF
C
C ALLOCATE DYNAMIC MEMORY
C
      ALLOCATE(SMI(IMI,JMI))
      ALLOCATE(SICEI(IMI,JMI))
      ALLOCATE(SMCI(IMI,JMI,NSOIL))
      ALLOCATE(STCI(IMI,JMI,NSOIL))
      ALLOCATE(CMCI(IMI,JMI))
      ALLOCATE(SH2OI(IMI,JMI,NSOIL))
c      ALLOCATE(IVGTPKI(IMI,JMI))
c      ALLOCATE(ISLTPKI(IMI,JMI))
c      ALLOCATE(ISPTPKI(IMI,JMI))
C
C INPUT EDAS LAND SURFACE STATES FROM NRESTRTI FILE
C
C SKIPPING:  2+LMI+3+LMI*9+14 RECORDS
C
      NSKIP=18+10*LMI
      DO ISKIP=1,NSKIP
        READ(NRESTRTI) 
      ENDDO
C
C READ SOIL MOISTURE (SMCI),CANOPY WATER (CMCI), SOIL TEMP (STCI)
C
      READ(NRESTRTI) SMCI
      READ(NRESTRTI) CMCI
      READ(NRESTRTI) STCI      
      READ(NRESTRTI) SH2OI
      if(mype.eq.0) print *,'SFCEDAS done reading nrestrti'
C
C INPUT EDAS LAND SURFACE CHARACTERISTICS FROM NHIBUI FILE
C
C SKIPPING:  6 RECORDS
C
      NSKIP=6
      DO ISKIP=1,NSKIP
        READ(NHIBUI) 
      ENDDO
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #1'
C
C READ SEA ICE/LAND MASK FLAGS:  SMI, SICEI
C
      READ(NHIBUI) SMI
      READ(NHIBUI) SICEI
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #2'
C
C SKIPPING:  LMI+LMI+24 RECORDS
C
      NSKIP=2*LMI+24
      DO ISKIP=1,NSKIP
        READ(NHIBUI) 
      ENDDO
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #3'
C
C READ TLM0D,TPH0D,DLMD,DPHD
      READ(NHIBUI) DUM12D,DUM22D,DUM3,DUM4,DUM5
     1  ,WBDX,SBDX,TLM0DX,TPH0DX,DLMDX,DPHDX
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #4'
c
      IF(TLM0DI.GT.0..AND.TLM0DX.LT.0..OR.
     1   TLM0DI.LT.0..AND.TLM0DX.GT.0.)TLM0DX=-TLM0DX
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #5'
C
C READ VEG TYPE (IVGTPKI), SOIL TYPE (ISLTPKI), SLOPE TYPE (ISPTPKI)
C
      READ(NHIBUI) IVGTPKI
      READ(NHIBUI) ISLTPKI
      READ(NHIBUI) ISPTPKI
      if(mype.eq.0)print *,'SFCEDAS done reading nhibui #6'
C
      REWIND 18  
      READ(18) HGTH
      REWIND 18  
      REWIND 19
      READ(19) HGTE
      REWIND 19
C
C-----------------------------------------------------------------------
C CHECK TO SEE THAT WBDI,SBDI,TLM0DI,TPH0DI,DLMDI,DPHDI FROM 'griddef.in'
C ARE THE SAME AS THOSE FROM THE INPUT ETA RESTART FILE (INPUT GRID)
C READ IN FROM NHIBU:  WBDX,SBDX,TLM0DX,TPH0DX,DLMDX,DPHDX
C
      if(mype.eq.0) then
        PRINT *,'griddef.in:'
        PRINT *,'TLM0DI,TPH0DI,WBDI,SBDI,DLMDI,DPHDI:',
     1	  TLM0DI,TPH0DI,WBDI,SBDI,DLMDI,DPHDI
        PRINT *,'INPUT READ FROM NHIBU:'
        PRINT *,'TLM0DX,TPH0DX,WBDX,SBDX,DLMDX,DPHDX:',
     1     TLM0DX,TPH0DX,WBDX,SBDX,DLMDX,DPHDX
      endif
     
      IF(ABS(TLM0DI-TLM0DX).GT.EPSLL.OR.
     2   ABS(TPH0DI-TPH0DX).GT.EPSLL.OR.
     3   ABS(WBDI-WBDX)    .GT.EPSLL.OR.
     4   ABS(SBDI-SBDX)    .GT.EPSLL.OR.
     5   ABS(DLMDI-DLMDX)  .GT.EPSLL.OR.
     6   ABS(DPHDI-DPHDX)  .GT.EPSLL)THEN
     
      if(mype.eq.0) then
        PRINT *,'***************************'
        PRINT *,'inconsistent griddef values'
        PRINT *,'***************************'
      endif
C      
c     STOP 887
      ENDIF
C-----------------------------------------------------------------------
C CHECK TO SEE THAT IMI,JMI FROM 'parmeta.resin'
C ARE THE SAME AS THOSE FROM CALCULATED VIA THE INPUT ETA RESTART FILE
C (INPUT GRID) READ IN FROM NHIBU:  IMX,JMX
C COMPUTE IMX,JMX FROM DATA IN NHIBU FILE
C
      IMX = NINT(ABS(WBDX)/DLMDX)+1
      JMX = NINT(ABS(SBDX)/DPHDX)*2 + 1
      
      if(mype.eq.0) then
        PRINT *,'parmeta.resin:'
        PRINT *,'IMI,JMI:',IMI,JMI
        PRINT *,'calculated via NHIBU:'
        PRINT *,'IMX,JMX:',IMX,JMX
      endif
C      
      IF ( (IMI .NE. IMX)  .OR.
     1     (JMI .NE. JMX) ) THEN
      if(mype.eq.0) then
        PRINT *,'**************************'
        PRINT *,'inconsistent IM,JM values'
        PRINT *,'**************************'
      endif
C      
c     STOP 888
      ENDIF
C
C-----------------------------------------------------------------------
C COMPUTE UPPER LIMIT (KRADUL) OF NEARBY NEIGHBOR SEARCH RADIUS
C BASED ON RATIO OF A 'TWO-DEGREE/INPUT GRID LATITUDE INTERVAL'
C SEARCH INTERVAL
C-----------------------------------------------------------------------
      KRADUL = 1+NINT(RADLAT/DPHDI)
      KRADUL = MIN(KRADUL,16)
      if(mype.eq.0)print*,'KRADUL',KRADUL
C
C ENTER PRIMARY TASK LOOP TO FIND NEAREST LAND NEIGHBOR AND
C ASSIGN NEAREST LAND NEIGHBOR STATES AND CHARACTERISTICS
C
      DO 200 J = JSTA,JEND 
        DO 100 I = 1, IM
C
C-----------------------------------------------------------------------
C IF NON LAND-MASS POINT, SKIP TO END OF LOOP (100)
C
          IF ((SM(I,J) .GT. 0.5) .OR. (SICE(I,J) .GT. 0.5)) GOTO 100
C
C DETERMINE LAT/LON OF TARGET GRID POINT
C
          GLATD = HLAT(I,J)
          GLOND = H360 - HLON(I,J)
C
C DETERMINE NEAREST NEIGHBOR FROM INPUT GRID
C
cwas          CALL LL2ETA(GLATD,GLOND,IMI,JMI,TPH0DI,TLM0DI,DPHDI,DLMDI,
cwas     1      II,JI)
          ii=ih2hx(i,j)
          ji=ih2hy(i,j)
C
C CHECK TO SEE THAT II,JI WITHIN IMI,JMI RANGE, IF NOT IN RANGE, THEN
C THE TARGET GRID POINT I,J IS OUTSIDE DOMAIN OF INPUT EDAS GRID,
C THEREFORE JUMP TO NEXT I INDEX LOOP (100), THUS RETAIN GDAS DEFAULT.
C
           IF ( (II .LT. 1) .OR. (II .GT. IMI) ) GOTO 100
           IF ( (JI .LT. 1) .OR. (JI .GT. JMI) ) GOTO 100
C
C-----------------------------------------------------------------------
C CHECK TO SEE IF NEAREST NEIGHBOR IS LAND MASS
C
          IF ((SMI(II,JI).GT. 0.5).OR.(SICEI(II,JI) .GT. 0.5)) THEN
C
C SEARCH FOR NEAREST LAND MASS NEIGHBOR (TO A LIMIT OF KRAD=KRADUL)
C
	    DO 50 KRAD=1,KRADUL
	      DO 40 JY = JI-KRAD,JI+KRAD
                DO 30 IX = II-KRAD,II+KRAD
C
C-----------------------------------------------------------------------
C CHECK TO SEE IF THIS NEAREST NEIGHBOR (IX,JY) STILL WITHIN IMI,JMI
C DOMAIN 
C
                  IF ( (IX .LT. 1) .OR. (IX .GT. IMI) ) GOTO 30
                  IF ( (JY .LT. 1) .OR. (JY .GT. JMI) ) GOTO 30
C
C CHECK TO SEE IF INPUT GRID POINT IS SEA OR SEA-ICE MASK
C
                  IF ((SMI(IX,JY)   .GT. 0.5) .OR.
     1                (SICEI(IX,JY) .GT. 0.5)) GOTO 30 
C
C WE HAVE FOUND A LAND POINT - REDEFINE II,JI
C
                    II=IX
		    JI=JY
c                   print *,'found land point at ii,ji ',ii,ji
		  GOTO 60
  30            CONTINUE
  40          CONTINUE
  50        CONTINUE
C
C END OF LOOP (50) REACHED WITH NO NEARBY LAND NEIGHBOR FOUND
C THEREFORE RETAIN GDAS DEFAULT
C-----------------------------------------------------------------------
C
c           PRINT *,'NO NEARBY LAND NEIGHBOR AT:',I,J,GLATD,GLOND
	    GOTO 100
          ENDIF
C
  60      CONTINUE
C
C USE STANDARD ATMOSPHERE LAPSE RATE TO ADJUST STC AND TG BY ELEVATION
C
          TDIFF = (HGTH(I,J) - HGTE(II,JI)) * 0.0065
C
C TAKE NEAREST LAND NEIGHBOR STATES
C
          IVGTPK(I,J) =IVGTPKI(II,JI)
          ISLTPK(I,J) =ISLTPKI(II,JI)
          ISPTPK(I,J) =ISPTPKI(II,JI)
          CMC(I,J)    =CMCI(II,JI)
C
          DO 70 K=1,NSOIL
            SMC(I,J,K)=SMCI(II,JI,K)
C
            IF(TDIFF.GT.0.65) THEN
             ORIGSH2 = SH2OI(II,JI,K)
             ORIGSTC = STCI(II,JI,K)
             STC(I,J,K)=ORIGSTC-TDIFF
C ----------------------------------------------------------------------
C SH2O <= SMC for T < 273.149K (-0.001C)
             IF (STC(I,J,K) .LT. 273.149) THEN
C ----------------------------------------------------------------------
C first guess following explicit solution for Flerchinger Eqn from Koren
C et al, JGR, 1999, Eqn 17 (KCOUNT=0 in FUNCTION FRH2O).
              BX = BETA(ISLTPK(I,J))
              IF ( BETA(ISLTPK(I,J)) .GT. BLIM ) BX = BLIM
              FK = (((HLICE/(GRAV*(-PSIS(ISLTPK(I,J)))))*
     1             ((STC(I,J,K)-T0)/STC(I,J,K)))**
     1             (-1/BX))*SMCMAX(ISLTPK(I,J))
              IF (FK .LT. 0.02) FK = 0.02
              SH2O(I,J,K) = MIN ( FK, SMC(I,J,K) )
C ----------------------------------------------------------------------
C now use iterative solution for liquid soil water content using
C FUNCTION FRH2O (from the Eta "NOAH" land-surface model) with the
C initial guess for SH2O from above explicit first guess.
              SH2O(I,J,K)=FRH2O(STC(I,J,K),SMC(I,J,K),SH2O(I,J,K),
     .                    SMCMAX(ISLTPK(I,J)),BETA(ISLTPK(I,J)),
     .                    PSIS(ISLTPK(I,J)))
C
              write(6,12346)mype,i,j,k,ORIGSTC,STC(I,J,K),
     1               ORIGSH2,SH2O(I,J,K),TDIFF,
     2               HGTH(I,J),HGTE(II,JI)
12346         format(1x,'stc adj ',4i6,7(1x,e11.4))
C
             ELSE
C ----------------------------------------------------------------------
C SH2O = SMC for T => 273.149K (-0.001C)
              SH2O(I,J,K)=SMCI(II,JI,K)
             ENDIF
            ELSE
             SH2O(I,J,K)=SH2OI(II,JI,K)
             STC(I,J,K)=STCI(II,JI,K)
            ENDIF
  70      CONTINUE
CER
          IF(TDIFF.GT.0.65) THEN
            ORIGTG=TG(I,J)
            TG(I,J)=ORIGTG-TDIFF
          ENDIF
CER
 100    CONTINUE
 200  CONTINUE
C
C DEALLOCATE DYNAMIC MEMORY
C
      DEALLOCATE(SMI)
      DEALLOCATE(SICEI)
      DEALLOCATE(SMCI)
      DEALLOCATE(STCI)
      DEALLOCATE(CMCI)
      DEALLOCATE(SH2OI)
c      DEALLOCATE(IVGTPKI)
c      DEALLOCATE(ISLTPKI)
c      DEALLOCATE(ISPTPKI)
C
      RETURN
      END
