      SUBROUTINE SST14K (SST,SM,GLAT,GLON)
C
      IMPLICIT REAL (A-H, O-Z)
C
      INCLUDE "parmeta.resout"
      INCLUDE "mpif.h"
      INCLUDE "MPI_PARM.comm"
C
      PARAMETER  (IM=IMO,JM=JMO)
      PARAMETER  (IMY=1041,JMY=441)
C
      PARAMETER  (H90=90.0,H360=360.0,D5=5.E-1,D00=0.0,H1=1.0)
      PARAMETER  (RAD2D=57.29578E0,PI=3.141592654)
C
C
C
      DIMENSION    SST14   (IMY,JMY)
C
      DIMENSION  SST(IM,JM), SM(IM,JM), GLAT(IM,JM), GLON(IM,JM)
      DIMENSION HLON(IM,JM),SSTOLD(IM,JM),HLAT(IM,JM)
C
C
      DATA   INSST/44/
C
C**************************  BEGIN EXECUTION ***********************
C
C      DO J=1,JMY
C        DO I=1,IMY
C
C   10N,195E is the lat/lon of the SW corner point of the
C   14 km SST grid
C
C          ALAT(I,J)=10.0 +(J-1)*HD5
C          ALON(I,J)=195.0+(I-1)*HD5
C        ENDDO
C      ENDDO
C
C  READ HI RESOLUTION 14 KM OPC SST ANALYSIS, CONVERT To KELVIN
C
      DO 25 I = 1, IMY
       READ (INSST,ERR=200,END=210) (SST14(I,J),J=1,JMY)
   25 CONTINUE
      CALL C2K(IMY,JMY,SST14)
C
C SWITCH TO EAST LONGITUDE 
C
      DO J = 1,JSTA,JEND
      DO I = 1,IM
        HLON(I,J) = 360.0 - (GLON(I,J)*RAD2D)
        HLAT(I,J) = GLAT(I,J) * RAD2D
      ENDDO
      ENDDO
C
C
C----  INTERPOLATE 1/8 DEG GLOBAL SATELLITE SST TO ETA GRID  -------
C
      DO J = 1,JSTA,JEND
      DO I = 1,IM
        SSTOLD(I,J)=SST(I,J)
      ENDDO
      ENDDO
C
C  TRY NEAREST NEIGHBOR
C
      DO J = 1,JSTA,JEND
      DO I = 1,IM
        JNIEB = INT(((HLAT(I,J)-10.0)*8.0)) + 1
        INIEB = INT(((HLON(I,J)-195.0)*8.0)) + 1
        IF(INIEB.GE.1.AND.JNIEB.GE.1) THEN
          IF(INIEB.LE.IMY.AND.JNIEB.LE.JMY) THEN
            SST(I,J) = SST14(INIEB,JNIEB)
            IF(SST(I,J).GT.308.0) THEN
              print *,'high sst at ',inieb,jnieb,i,j,sst(i,j),
     1          hlat(i,j),hlon(i,j),sstold(i,j),mype
            ENDIF
          ENDIF
        ENDIF
      ENDDO
      ENDDO
C
C   REACHING HERE MEANS 14KM SST READ OK
C
      RETURN
C
C   REACHING HERE MEANS SOMETHING IS WRONG
C
  200 CONTINUE      !  SOME KIND OF ERROR READING FILE
      WRITE(6,555) INSST
  210 CONTINUE      !  HIT UNEXPECTED END O' FILE
      WRITE(6,556) INSST
  555 FORMAT ('0', 'ERROR OCCURRED WHEN READING IN 14 KM SST        ',
     1             'ON UNIT', I3, ': SKIPPING 14 KM SST FIELD.')
  556 FORMAT ('0', 'HIT UNEXPECTED END OF FILE READING 14K SST',
     1             'ON UNIT', I3, ': SKIPPING 14 KM SST FIELD.')
      RETURN
      END
